package sha256

import (
	// Standard
	"crypto/sha256"
	"encoding/hex"
)

// Hash
func (Algorithm) Hash(data []byte) (string, error) {
	// Hasher
	hasher := sha256.New()
	// Write To Hasher
	_, err := hasher.Write(data)
	// Handle Error
	if err != nil {
		return "", err
	}
	// Return Hash
	return hex.EncodeToString(hasher.Sum(nil)), err
}
